> For the complete documentation index, see [llms.txt](https://docs.frends.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.frends.com/reference/frends-platform-api/platform-api-reference/models.md).

# Models

## The AcknowledgeInstanceErrorsQueryModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"AcknowledgeInstanceErrorsQueryModel":{"required":["reason","instanceIds"],"type":"object","properties":{"reason":{"type":"string"},"instanceIds":{"type":"array","items":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"}}}}}}}
```

## The AcmeProviderInfo object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"AcmeProviderInfo":{"required":["name","directoryUrl","requiresExternalAccountBinding"],"type":"object","properties":{"name":{"type":"string","description":"Provider name"},"directoryUrl":{"type":"string","description":"ACME directory URL"},"requiresExternalAccountBinding":{"type":"boolean","description":"Whether this provider requires external account binding (EAB)"},"issuerDomainName":{"type":["null","string"],"description":"Issuer domain name for the dns-persist-01 challenge's TXT record value; null when this provider doesn't offer the challenge type"}}}}}}
```

## The AcmeRevocationReason object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"AcmeRevocationReason":{"enum":["Unspecified","KeyCompromise","Superseded","CessationOfOperation"],"default":"Unspecified"}}}}
```

## The AgentEventViewModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"AgentEventViewModel":{"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"eventId":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"level":{"type":"string"},"utcTimestamp":{"type":"string","format":"date-time"},"category":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"source":{"type":"string"},"message":{"type":"string"}}}}}}
```

## The AgentRegistrationMode object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"AgentRegistrationMode":{"enum":["SelfHosted","Deployment","Cloud","StatefulSet"]}}}}
```

## The ApiAccessRuleType object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiAccessRuleType":{"enum":["Allow","Deny"]}}}}
```

## The ApiKey object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiKey":{"required":["name","environment","modifier"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":"string"},"value":{"type":"string","format":"uuid"},"environment":{"type":"string"},"modified":{"type":"string","format":"date-time"},"modifier":{"type":"string"},"groupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignment"}}}},"ApiPolicyApiKeyGroupAssignment":{"required":["apiKey","apiKeyGroup"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiKey":{"$ref":"#/components/schemas/ApiKey"},"apiKeyGroup":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroup"}}},"ApiPolicyApiKeyGroup":{"required":["apiPolicy","name"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"name":{"type":"string"},"keyGroupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignment"}},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"ApiPolicy":{"required":["uniqueIdentifier","name","modifier","apiKeyName","apiKeyLocation"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"uniqueIdentifier":{"type":"string","format":"uuid"},"name":{"type":"string"},"deletedUtc":{"type":["null","string"],"format":"date-time"},"description":{"type":["null","string"]},"modifier":{"type":"string"},"modifiedUtc":{"type":"string","format":"date-time"},"allowPublicAccess":{"type":"boolean"},"apiKeyName":{"type":"string"},"apiKeyLocation":{"$ref":"#/components/schemas/ParameterLocation"},"targetEndpoints":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyTargetEndpoint"}},"identities":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyIdentity"}},"apiKeyGroups":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroup"}},"requestLoggings":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyRequestLogging"}}}},"ParameterLocation":{"enum":["Query","Header","Path","Cookie"]},"ApiPolicyTargetEndpoint":{"required":["apiPolicy","path"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"path":{"type":"string"},"method":{"$ref":"#/components/schemas/PolicyEndpointMethod"},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"PolicyEndpointMethod":{"enum":["All","Get","Post","Put","Head","Delete","Patch","Options","Connect","Trace"]},"ApiPolicyIdentity":{"required":["apiPolicy"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"isPrivateApplication":{"type":"boolean"},"issuersJson":{"type":"string"},"name":{"type":"string"},"throttlingByClaim":{"type":["null","string"]},"priorityNumber":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"identityRules":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPolicyIdentityRule"}},"deployments":{},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"ApiPolicyIdentityRule":{"required":["identity"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"identity":{"$ref":"#/components/schemas/ApiPolicyIdentity"},"ruleType":{"$ref":"#/components/schemas/ApiAccessRuleType"},"claim":{"type":"string"},"value":{"type":"string"},"matchType":{"$ref":"#/components/schemas/IdentityRuleMatchType"}}},"ApiAccessRuleType":{"enum":["Allow","Deny"]},"IdentityRuleMatchType":{"enum":["Exact","Exists","Regex"]},"ApiPolicyRequestLogging":{"required":["name","apiPolicy","loggingFieldsJson","ipLogging"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":"string"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"loggingFieldsJson":{"type":"string"},"ipLogging":{"$ref":"#/components/schemas/IpLoggingType"},"requestBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"responseBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"disableLogging":{"type":"boolean"},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyRequestLoggingDeployment"}}}},"IpLoggingType":{"enum":["ClientIP","ClientIPXForwardedForFirst","ClientIPXForwardedForAll","Disable"]},"ApiPolicyRequestLoggingDeployment":{"required":["apiPolicyRequestLogging","agentGroupName","deployer"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicyRequestLogging":{"$ref":"#/components/schemas/ApiPolicyRequestLogging"},"agentGroupName":{"type":"string"},"deployer":{"type":"string"},"deployedUtc":{"type":"string","format":"date-time"}}}}}}
```

## The ApiKeyViewModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiKeyViewModel":{"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":["null","string"]},"environment":{"type":["null","string"]},"value":{"type":"string","format":"uuid"}}}}}}
```

## The ApiPassthroughCreateModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPassthroughCreateModel":{"required":["path","method","isDefault","corsEnabled","targetUrl","headers","allowedOrigins"],"type":"object","properties":{"path":{"type":["null","string"],"description":"Source API path for this passthrough configuration. Not used when IsDefault is set to true."},"method":{"type":["null","string"],"description":"HTTP method. Not used when IsDefault is set to true."},"isDefault":{"type":"boolean","description":"Is this configuration used for all paths and HTTP methods"},"corsEnabled":{"type":"boolean","description":"Is CORS enabled"},"targetUrl":{"description":"Target URL","$ref":"#/components/schemas/ApiPassthroughTarget"},"headers":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPassthroughHeader"},"description":"Header definitions"},"allowedOrigins":{"type":["null","array"],"items":{"type":"string"},"description":"Allowed origins. Used when CORS is enabled."}}},"ApiPassthroughTarget":{"required":["server","basePath","operationPath","query"],"type":"object","properties":{"server":{"type":"string","description":"Server part of the target URL"},"basePath":{"type":"string","description":"Base path of the target URL"},"operationPath":{"type":["null","string"],"description":"Operation path of the target URL"},"query":{"type":["null","string"],"description":"Query parameters of the target URL"}}},"ApiPassthroughHeader":{"required":["action","name","value"],"type":"object","properties":{"action":{"type":"string","description":"Header action (Add, Overwrite, Remove)"},"name":{"type":"string","description":"Header name"},"value":{"type":"string","description":"Header value"}}}}}}
```

## The ApiPassthroughEditModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPassthroughEditModel":{"required":["corsEnabled","targetUrl","headers","allowedOrigins"],"type":"object","properties":{"corsEnabled":{"type":"boolean","description":"Is CORS enabled"},"targetUrl":{"description":"Target URL","$ref":"#/components/schemas/ApiPassthroughTarget"},"headers":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPassthroughHeader"},"description":"Header definitions"},"allowedOrigins":{"type":["null","array"],"items":{"type":"string"},"description":"Allowed origins. Used when CORS is enabled."}}},"ApiPassthroughTarget":{"required":["server","basePath","operationPath","query"],"type":"object","properties":{"server":{"type":"string","description":"Server part of the target URL"},"basePath":{"type":"string","description":"Base path of the target URL"},"operationPath":{"type":["null","string"],"description":"Operation path of the target URL"},"query":{"type":["null","string"],"description":"Query parameters of the target URL"}}},"ApiPassthroughHeader":{"required":["action","name","value"],"type":"object","properties":{"action":{"type":"string","description":"Header action (Add, Overwrite, Remove)"},"name":{"type":"string","description":"Header name"},"value":{"type":"string","description":"Header value"}}}}}}
```

## The ApiPassthroughHeader object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPassthroughHeader":{"required":["action","name","value"],"type":"object","properties":{"action":{"type":"string","description":"Header action (Add, Overwrite, Remove)"},"name":{"type":"string","description":"Header name"},"value":{"type":"string","description":"Header value"}}}}}}
```

## The ApiPassthroughTarget object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPassthroughTarget":{"required":["server","basePath","operationPath","query"],"type":"object","properties":{"server":{"type":"string","description":"Server part of the target URL"},"basePath":{"type":"string","description":"Base path of the target URL"},"operationPath":{"type":["null","string"],"description":"Operation path of the target URL"},"query":{"type":["null","string"],"description":"Query parameters of the target URL"}}}}}}
```

## The ApiPassthroughViewModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPassthroughViewModel":{"required":["id","apiVersionId","modifier","modified","path","method","isDefault","corsEnabled","targetUrl","headers","allowedOrigins"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Unique identifier of the passthrough configuration","format":"int64"},"apiVersionId":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Unique identifier of the API version","format":"int64"},"modifier":{"type":"string","description":"User who last modified the configuration"},"modified":{"type":"string","description":"Time when configuration was last modified","format":"date-time"},"path":{"type":["null","string"],"description":"Source API path for this passthrough configuration. Not used when IsDefault is set to true."},"method":{"type":["null","string"],"description":"HTTP method. Not used when IsDefault is set to true."},"isDefault":{"type":"boolean","description":"Is this configuration used for all paths and HTTP methods"},"corsEnabled":{"type":"boolean","description":"Is CORS enabled"},"targetUrl":{"description":"Target URL","$ref":"#/components/schemas/ApiPassthroughTarget"},"headers":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPassthroughHeader"},"description":"Header definitions"},"allowedOrigins":{"type":["null","array"],"items":{"type":"string"},"description":"Allowed origins. Used when CORS is enabled."}}},"ApiPassthroughTarget":{"required":["server","basePath","operationPath","query"],"type":"object","properties":{"server":{"type":"string","description":"Server part of the target URL"},"basePath":{"type":"string","description":"Base path of the target URL"},"operationPath":{"type":["null","string"],"description":"Operation path of the target URL"},"query":{"type":["null","string"],"description":"Query parameters of the target URL"}}},"ApiPassthroughHeader":{"required":["action","name","value"],"type":"object","properties":{"action":{"type":"string","description":"Header action (Add, Overwrite, Remove)"},"name":{"type":"string","description":"Header name"},"value":{"type":"string","description":"Header value"}}}}}}
```

## The ApiPolicy object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicy":{"required":["uniqueIdentifier","name","modifier","apiKeyName","apiKeyLocation"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"uniqueIdentifier":{"type":"string","format":"uuid"},"name":{"type":"string"},"deletedUtc":{"type":["null","string"],"format":"date-time"},"description":{"type":["null","string"]},"modifier":{"type":"string"},"modifiedUtc":{"type":"string","format":"date-time"},"allowPublicAccess":{"type":"boolean"},"apiKeyName":{"type":"string"},"apiKeyLocation":{"$ref":"#/components/schemas/ParameterLocation"},"targetEndpoints":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyTargetEndpoint"}},"identities":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyIdentity"}},"apiKeyGroups":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroup"}},"requestLoggings":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyRequestLogging"}}}},"ParameterLocation":{"enum":["Query","Header","Path","Cookie"]},"ApiPolicyTargetEndpoint":{"required":["apiPolicy","path"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"path":{"type":"string"},"method":{"$ref":"#/components/schemas/PolicyEndpointMethod"},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"ApiPolicyIdentity":{"required":["apiPolicy"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"isPrivateApplication":{"type":"boolean"},"issuersJson":{"type":"string"},"name":{"type":"string"},"throttlingByClaim":{"type":["null","string"]},"priorityNumber":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"identityRules":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPolicyIdentityRule"}},"deployments":{},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"ApiPolicyIdentityRule":{"required":["identity"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"identity":{"$ref":"#/components/schemas/ApiPolicyIdentity"},"ruleType":{"$ref":"#/components/schemas/ApiAccessRuleType"},"claim":{"type":"string"},"value":{"type":"string"},"matchType":{"$ref":"#/components/schemas/IdentityRuleMatchType"}}},"ApiAccessRuleType":{"enum":["Allow","Deny"]},"IdentityRuleMatchType":{"enum":["Exact","Exists","Regex"]},"ApiPolicyApiKeyGroup":{"required":["apiPolicy","name"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"name":{"type":"string"},"keyGroupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignment"}},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"ApiPolicyApiKeyGroupAssignment":{"required":["apiKey","apiKeyGroup"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiKey":{"$ref":"#/components/schemas/ApiKey"},"apiKeyGroup":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroup"}}},"ApiKey":{"required":["name","environment","modifier"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":"string"},"value":{"type":"string","format":"uuid"},"environment":{"type":"string"},"modified":{"type":"string","format":"date-time"},"modifier":{"type":"string"},"groupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignment"}}}},"ApiPolicyRequestLogging":{"required":["name","apiPolicy","loggingFieldsJson","ipLogging"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":"string"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"loggingFieldsJson":{"type":"string"},"ipLogging":{"$ref":"#/components/schemas/IpLoggingType"},"requestBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"responseBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"disableLogging":{"type":"boolean"},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyRequestLoggingDeployment"}}}},"IpLoggingType":{"enum":["ClientIP","ClientIPXForwardedForFirst","ClientIPXForwardedForAll","Disable"]},"ApiPolicyRequestLoggingDeployment":{"required":["apiPolicyRequestLogging","agentGroupName","deployer"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicyRequestLogging":{"$ref":"#/components/schemas/ApiPolicyRequestLogging"},"agentGroupName":{"type":"string"},"deployer":{"type":"string"},"deployedUtc":{"type":"string","format":"date-time"}}},"PolicyEndpointMethod":{"enum":["All","Get","Post","Put","Head","Delete","Patch","Options","Connect","Trace"]}}}}
```

## The ApiPolicyApiKeyGroup object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyApiKeyGroup":{"required":["apiPolicy","name"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"name":{"type":"string"},"keyGroupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignment"}},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"ApiPolicy":{"required":["uniqueIdentifier","name","modifier","apiKeyName","apiKeyLocation"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"uniqueIdentifier":{"type":"string","format":"uuid"},"name":{"type":"string"},"deletedUtc":{"type":["null","string"],"format":"date-time"},"description":{"type":["null","string"]},"modifier":{"type":"string"},"modifiedUtc":{"type":"string","format":"date-time"},"allowPublicAccess":{"type":"boolean"},"apiKeyName":{"type":"string"},"apiKeyLocation":{"$ref":"#/components/schemas/ParameterLocation"},"targetEndpoints":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyTargetEndpoint"}},"identities":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyIdentity"}},"apiKeyGroups":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroup"}},"requestLoggings":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyRequestLogging"}}}},"ParameterLocation":{"enum":["Query","Header","Path","Cookie"]},"ApiPolicyTargetEndpoint":{"required":["apiPolicy","path"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"path":{"type":"string"},"method":{"$ref":"#/components/schemas/PolicyEndpointMethod"},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"PolicyEndpointMethod":{"enum":["All","Get","Post","Put","Head","Delete","Patch","Options","Connect","Trace"]},"ApiPolicyIdentity":{"required":["apiPolicy"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"isPrivateApplication":{"type":"boolean"},"issuersJson":{"type":"string"},"name":{"type":"string"},"throttlingByClaim":{"type":["null","string"]},"priorityNumber":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"identityRules":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPolicyIdentityRule"}},"deployments":{},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"ApiPolicyIdentityRule":{"required":["identity"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"identity":{"$ref":"#/components/schemas/ApiPolicyIdentity"},"ruleType":{"$ref":"#/components/schemas/ApiAccessRuleType"},"claim":{"type":"string"},"value":{"type":"string"},"matchType":{"$ref":"#/components/schemas/IdentityRuleMatchType"}}},"ApiAccessRuleType":{"enum":["Allow","Deny"]},"IdentityRuleMatchType":{"enum":["Exact","Exists","Regex"]},"ApiPolicyApiKeyGroupAssignment":{"required":["apiKey","apiKeyGroup"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiKey":{"$ref":"#/components/schemas/ApiKey"},"apiKeyGroup":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroup"}}},"ApiKey":{"required":["name","environment","modifier"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":"string"},"value":{"type":"string","format":"uuid"},"environment":{"type":"string"},"modified":{"type":"string","format":"date-time"},"modifier":{"type":"string"},"groupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignment"}}}},"ApiPolicyRequestLogging":{"required":["name","apiPolicy","loggingFieldsJson","ipLogging"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":"string"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"loggingFieldsJson":{"type":"string"},"ipLogging":{"$ref":"#/components/schemas/IpLoggingType"},"requestBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"responseBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"disableLogging":{"type":"boolean"},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyRequestLoggingDeployment"}}}},"IpLoggingType":{"enum":["ClientIP","ClientIPXForwardedForFirst","ClientIPXForwardedForAll","Disable"]},"ApiPolicyRequestLoggingDeployment":{"required":["apiPolicyRequestLogging","agentGroupName","deployer"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicyRequestLogging":{"$ref":"#/components/schemas/ApiPolicyRequestLogging"},"agentGroupName":{"type":"string"},"deployer":{"type":"string"},"deployedUtc":{"type":"string","format":"date-time"}}}}}}
```

## The ApiPolicyApiKeyGroupAssignment object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyApiKeyGroupAssignment":{"required":["apiKey","apiKeyGroup"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiKey":{"$ref":"#/components/schemas/ApiKey"},"apiKeyGroup":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroup"}}},"ApiKey":{"required":["name","environment","modifier"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":"string"},"value":{"type":"string","format":"uuid"},"environment":{"type":"string"},"modified":{"type":"string","format":"date-time"},"modifier":{"type":"string"},"groupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignment"}}}},"ApiPolicyApiKeyGroup":{"required":["apiPolicy","name"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"name":{"type":"string"},"keyGroupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignment"}},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"ApiPolicy":{"required":["uniqueIdentifier","name","modifier","apiKeyName","apiKeyLocation"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"uniqueIdentifier":{"type":"string","format":"uuid"},"name":{"type":"string"},"deletedUtc":{"type":["null","string"],"format":"date-time"},"description":{"type":["null","string"]},"modifier":{"type":"string"},"modifiedUtc":{"type":"string","format":"date-time"},"allowPublicAccess":{"type":"boolean"},"apiKeyName":{"type":"string"},"apiKeyLocation":{"$ref":"#/components/schemas/ParameterLocation"},"targetEndpoints":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyTargetEndpoint"}},"identities":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyIdentity"}},"apiKeyGroups":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroup"}},"requestLoggings":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyRequestLogging"}}}},"ParameterLocation":{"enum":["Query","Header","Path","Cookie"]},"ApiPolicyTargetEndpoint":{"required":["apiPolicy","path"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"path":{"type":"string"},"method":{"$ref":"#/components/schemas/PolicyEndpointMethod"},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"PolicyEndpointMethod":{"enum":["All","Get","Post","Put","Head","Delete","Patch","Options","Connect","Trace"]},"ApiPolicyIdentity":{"required":["apiPolicy"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"isPrivateApplication":{"type":"boolean"},"issuersJson":{"type":"string"},"name":{"type":"string"},"throttlingByClaim":{"type":["null","string"]},"priorityNumber":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"identityRules":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPolicyIdentityRule"}},"deployments":{},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"ApiPolicyIdentityRule":{"required":["identity"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"identity":{"$ref":"#/components/schemas/ApiPolicyIdentity"},"ruleType":{"$ref":"#/components/schemas/ApiAccessRuleType"},"claim":{"type":"string"},"value":{"type":"string"},"matchType":{"$ref":"#/components/schemas/IdentityRuleMatchType"}}},"ApiAccessRuleType":{"enum":["Allow","Deny"]},"IdentityRuleMatchType":{"enum":["Exact","Exists","Regex"]},"ApiPolicyRequestLogging":{"required":["name","apiPolicy","loggingFieldsJson","ipLogging"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":"string"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"loggingFieldsJson":{"type":"string"},"ipLogging":{"$ref":"#/components/schemas/IpLoggingType"},"requestBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"responseBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"disableLogging":{"type":"boolean"},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyRequestLoggingDeployment"}}}},"IpLoggingType":{"enum":["ClientIP","ClientIPXForwardedForFirst","ClientIPXForwardedForAll","Disable"]},"ApiPolicyRequestLoggingDeployment":{"required":["apiPolicyRequestLogging","agentGroupName","deployer"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicyRequestLogging":{"$ref":"#/components/schemas/ApiPolicyRequestLogging"},"agentGroupName":{"type":"string"},"deployer":{"type":"string"},"deployedUtc":{"type":"string","format":"date-time"}}}}}}
```

## The ApiPolicyApiKeyGroupAssignmentSaveModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyApiKeyGroupAssignmentSaveModel":{"required":["apiKey"],"type":"object","properties":{"apiKey":{"description":"The API key","$ref":"#/components/schemas/ApiPolicyApiKeySaveModel"}}},"ApiPolicyApiKeySaveModel":{"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The API key identifier","format":"int64"}}}}}}
```

## The ApiPolicyApiKeyGroupAssignmentViewModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyApiKeyGroupAssignmentViewModel":{"required":["apiKey"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The identifier of the assignment","format":"int64"},"apiKey":{"description":"The API key","$ref":"#/components/schemas/ApiKeyViewModel"}}},"ApiKeyViewModel":{"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":["null","string"]},"environment":{"type":["null","string"]},"value":{"type":"string","format":"uuid"}}}}}}
```

## The ApiPolicyApiKeyGroupSaveModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyApiKeyGroupSaveModel":{"required":["apiPolicyApiKeyGroupAssignments","name"],"type":"object","properties":{"apiPolicyApiKeyGroupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignmentSaveModel"},"description":"The API key group assignments"},"name":{"type":"string","description":"The name of the API key group"},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32"}}},"ApiPolicyApiKeyGroupAssignmentSaveModel":{"required":["apiKey"],"type":"object","properties":{"apiKey":{"description":"The API key","$ref":"#/components/schemas/ApiPolicyApiKeySaveModel"}}},"ApiPolicyApiKeySaveModel":{"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The API key identifier","format":"int64"}}}}}}
```

## The ApiPolicyApiKeyGroupViewModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyApiKeyGroupViewModel":{"required":["name"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The unique identifier of the API key group","format":"int64"},"apiPolicyApiKeyGroupAssignments":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignmentViewModel"},"description":"The API group assignments"},"name":{"type":"string","description":"The name of the API key group"},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32"}}},"ApiPolicyApiKeyGroupAssignmentViewModel":{"required":["apiKey"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The identifier of the assignment","format":"int64"},"apiKey":{"description":"The API key","$ref":"#/components/schemas/ApiKeyViewModel"}}},"ApiKeyViewModel":{"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":["null","string"]},"environment":{"type":["null","string"]},"value":{"type":"string","format":"uuid"}}}}}}
```

## The ApiPolicyApiKeySaveModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyApiKeySaveModel":{"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The API key identifier","format":"int64"}}}}}}
```

## The ApiPolicyDeploymentSaveModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyDeploymentSaveModel":{"required":["agentGroupName"],"type":"object","properties":{"agentGroupName":{"type":"string","description":"The Agent Group associated with the deployment"}}}}}}
```

## The ApiPolicyDeploymentViewModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyDeploymentViewModel":{"required":["agentGroupName"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The unique identifier of the deployment","format":"int64"},"deployerUserName":{"type":"string","description":"The username of the deployer"},"deployedUtc":{"type":"string","description":"The timestamp when the deployment occurred","format":"date-time"},"agentGroupName":{"type":"string","description":"The Agent Group associated with the deployment"}}}}}}
```

## The ApiPolicyIdentity object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyIdentity":{"required":["apiPolicy"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"isPrivateApplication":{"type":"boolean"},"issuersJson":{"type":"string"},"name":{"type":"string"},"throttlingByClaim":{"type":["null","string"]},"priorityNumber":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"identityRules":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPolicyIdentityRule"}},"deployments":{},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"ApiPolicy":{"required":["uniqueIdentifier","name","modifier","apiKeyName","apiKeyLocation"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"uniqueIdentifier":{"type":"string","format":"uuid"},"name":{"type":"string"},"deletedUtc":{"type":["null","string"],"format":"date-time"},"description":{"type":["null","string"]},"modifier":{"type":"string"},"modifiedUtc":{"type":"string","format":"date-time"},"allowPublicAccess":{"type":"boolean"},"apiKeyName":{"type":"string"},"apiKeyLocation":{"$ref":"#/components/schemas/ParameterLocation"},"targetEndpoints":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyTargetEndpoint"}},"identities":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyIdentity"}},"apiKeyGroups":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroup"}},"requestLoggings":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyRequestLogging"}}}},"ParameterLocation":{"enum":["Query","Header","Path","Cookie"]},"ApiPolicyTargetEndpoint":{"required":["apiPolicy","path"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"path":{"type":"string"},"method":{"$ref":"#/components/schemas/PolicyEndpointMethod"},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"PolicyEndpointMethod":{"enum":["All","Get","Post","Put","Head","Delete","Patch","Options","Connect","Trace"]},"ApiPolicyIdentityRule":{"required":["identity"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"identity":{"$ref":"#/components/schemas/ApiPolicyIdentity"},"ruleType":{"$ref":"#/components/schemas/ApiAccessRuleType"},"claim":{"type":"string"},"value":{"type":"string"},"matchType":{"$ref":"#/components/schemas/IdentityRuleMatchType"}}},"ApiAccessRuleType":{"enum":["Allow","Deny"]},"IdentityRuleMatchType":{"enum":["Exact","Exists","Regex"]},"ApiPolicyApiKeyGroup":{"required":["apiPolicy","name"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"name":{"type":"string"},"keyGroupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignment"}},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"ApiPolicyApiKeyGroupAssignment":{"required":["apiKey","apiKeyGroup"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiKey":{"$ref":"#/components/schemas/ApiKey"},"apiKeyGroup":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroup"}}},"ApiKey":{"required":["name","environment","modifier"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":"string"},"value":{"type":"string","format":"uuid"},"environment":{"type":"string"},"modified":{"type":"string","format":"date-time"},"modifier":{"type":"string"},"groupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignment"}}}},"ApiPolicyRequestLogging":{"required":["name","apiPolicy","loggingFieldsJson","ipLogging"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":"string"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"loggingFieldsJson":{"type":"string"},"ipLogging":{"$ref":"#/components/schemas/IpLoggingType"},"requestBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"responseBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"disableLogging":{"type":"boolean"},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyRequestLoggingDeployment"}}}},"IpLoggingType":{"enum":["ClientIP","ClientIPXForwardedForFirst","ClientIPXForwardedForAll","Disable"]},"ApiPolicyRequestLoggingDeployment":{"required":["apiPolicyRequestLogging","agentGroupName","deployer"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicyRequestLogging":{"$ref":"#/components/schemas/ApiPolicyRequestLogging"},"agentGroupName":{"type":"string"},"deployer":{"type":"string"},"deployedUtc":{"type":"string","format":"date-time"}}}}}}
```

## The ApiPolicyIdentityRule object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyIdentityRule":{"required":["identity"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"identity":{"$ref":"#/components/schemas/ApiPolicyIdentity"},"ruleType":{"$ref":"#/components/schemas/ApiAccessRuleType"},"claim":{"type":"string"},"value":{"type":"string"},"matchType":{"$ref":"#/components/schemas/IdentityRuleMatchType"}}},"ApiPolicyIdentity":{"required":["apiPolicy"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"isPrivateApplication":{"type":"boolean"},"issuersJson":{"type":"string"},"name":{"type":"string"},"throttlingByClaim":{"type":["null","string"]},"priorityNumber":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"identityRules":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPolicyIdentityRule"}},"deployments":{},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"ApiPolicy":{"required":["uniqueIdentifier","name","modifier","apiKeyName","apiKeyLocation"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"uniqueIdentifier":{"type":"string","format":"uuid"},"name":{"type":"string"},"deletedUtc":{"type":["null","string"],"format":"date-time"},"description":{"type":["null","string"]},"modifier":{"type":"string"},"modifiedUtc":{"type":"string","format":"date-time"},"allowPublicAccess":{"type":"boolean"},"apiKeyName":{"type":"string"},"apiKeyLocation":{"$ref":"#/components/schemas/ParameterLocation"},"targetEndpoints":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyTargetEndpoint"}},"identities":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyIdentity"}},"apiKeyGroups":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroup"}},"requestLoggings":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyRequestLogging"}}}},"ParameterLocation":{"enum":["Query","Header","Path","Cookie"]},"ApiPolicyTargetEndpoint":{"required":["apiPolicy","path"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"path":{"type":"string"},"method":{"$ref":"#/components/schemas/PolicyEndpointMethod"},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"PolicyEndpointMethod":{"enum":["All","Get","Post","Put","Head","Delete","Patch","Options","Connect","Trace"]},"ApiPolicyApiKeyGroup":{"required":["apiPolicy","name"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"name":{"type":"string"},"keyGroupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignment"}},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"ApiPolicyApiKeyGroupAssignment":{"required":["apiKey","apiKeyGroup"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiKey":{"$ref":"#/components/schemas/ApiKey"},"apiKeyGroup":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroup"}}},"ApiKey":{"required":["name","environment","modifier"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":"string"},"value":{"type":"string","format":"uuid"},"environment":{"type":"string"},"modified":{"type":"string","format":"date-time"},"modifier":{"type":"string"},"groupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignment"}}}},"ApiPolicyRequestLogging":{"required":["name","apiPolicy","loggingFieldsJson","ipLogging"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":"string"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"loggingFieldsJson":{"type":"string"},"ipLogging":{"$ref":"#/components/schemas/IpLoggingType"},"requestBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"responseBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"disableLogging":{"type":"boolean"},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyRequestLoggingDeployment"}}}},"IpLoggingType":{"enum":["ClientIP","ClientIPXForwardedForFirst","ClientIPXForwardedForAll","Disable"]},"ApiPolicyRequestLoggingDeployment":{"required":["apiPolicyRequestLogging","agentGroupName","deployer"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicyRequestLogging":{"$ref":"#/components/schemas/ApiPolicyRequestLogging"},"agentGroupName":{"type":"string"},"deployer":{"type":"string"},"deployedUtc":{"type":"string","format":"date-time"}}},"ApiAccessRuleType":{"enum":["Allow","Deny"]},"IdentityRuleMatchType":{"enum":["Exact","Exists","Regex"]}}}}
```

## The ApiPolicyIdentityRuleSaveModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyIdentityRuleSaveModel":{"required":["claim"],"type":"object","properties":{"ruleType":{"description":"The type of access rule","$ref":"#/components/schemas/ApiAccessRuleType"},"claim":{"type":"string","description":"The claim associated with the identity rule"},"value":{"type":["null","string"],"description":"The value associated with the identity rule"},"matchType":{"description":"The match type of the identity rule","$ref":"#/components/schemas/IdentityRuleMatchType"}}},"ApiAccessRuleType":{"enum":["Allow","Deny"]},"IdentityRuleMatchType":{"enum":["Exact","Exists","Regex"]}}}}
```

## The ApiPolicyIdentityRuleViewModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyIdentityRuleViewModel":{"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The unique identifier of the identity rule","format":"int64"},"ruleType":{"description":"The type of access rule","$ref":"#/components/schemas/ApiAccessRuleType"},"claim":{"type":["null","string"],"description":"The claim associated with the identity rule"},"value":{"type":["null","string"],"description":"The value associated with the identity rule"},"matchType":{"description":"The match type of the identity rule","$ref":"#/components/schemas/IdentityRuleMatchType"}}},"ApiAccessRuleType":{"enum":["Allow","Deny"]},"IdentityRuleMatchType":{"enum":["Exact","Exists","Regex"]}}}}
```

## The ApiPolicyIdentitySaveModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyIdentitySaveModel":{"required":["deployments","issuers","name"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The unique identifier of the identity. Only provide a value when updating.","format":"int64"},"identityRules":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPolicyIdentityRuleSaveModel"},"description":"The list of identity rules"},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyDeploymentSaveModel"},"description":"The list of deployments associated with the identity"},"isPrivateApplication":{"type":"boolean","description":"Determines if it is a private application"},"issuers":{"description":"The issuers of the identity","$ref":"#/components/schemas/JsonArray"},"name":{"type":"string","description":"The name of the identity"},"throttlingByClaim":{"type":["null","string"],"description":"The throttling by claim for the identity"},"priorityNumber":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"In case of 2 or more matching identities, determines which identity to use. Lower number will be selected.","format":"int32"},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32"}}},"ApiPolicyIdentityRuleSaveModel":{"required":["claim"],"type":"object","properties":{"ruleType":{"description":"The type of access rule","$ref":"#/components/schemas/ApiAccessRuleType"},"claim":{"type":"string","description":"The claim associated with the identity rule"},"value":{"type":["null","string"],"description":"The value associated with the identity rule"},"matchType":{"description":"The match type of the identity rule","$ref":"#/components/schemas/IdentityRuleMatchType"}}},"ApiAccessRuleType":{"enum":["Allow","Deny"]},"IdentityRuleMatchType":{"enum":["Exact","Exists","Regex"]},"ApiPolicyDeploymentSaveModel":{"required":["agentGroupName"],"type":"object","properties":{"agentGroupName":{"type":"string","description":"The Agent Group associated with the deployment"}}},"JsonArray":{"type":"array"}}}}
```

## The ApiPolicyIdentityViewModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyIdentityViewModel":{"required":["issuers","name"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The unique identifier of the identity","format":"int64"},"identityRules":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyIdentityRuleViewModel"}},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyDeploymentViewModel"},"description":"The list of deployments associated with the identity"},"isPrivateApplication":{"type":"boolean","description":"Determines if it is a private application"},"issuers":{"description":"The issuers of the identity","$ref":"#/components/schemas/JsonArray"},"name":{"type":"string","description":"The name of the identity"},"throttlingByClaim":{"type":["null","string"],"description":"The throttling by claim for the identity"},"priorityNumber":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"In case of 2 or more matching identities, determines which identity to use. Lower number will be selected.","format":"int32"},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32"}}},"ApiPolicyIdentityRuleViewModel":{"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The unique identifier of the identity rule","format":"int64"},"ruleType":{"description":"The type of access rule","$ref":"#/components/schemas/ApiAccessRuleType"},"claim":{"type":["null","string"],"description":"The claim associated with the identity rule"},"value":{"type":["null","string"],"description":"The value associated with the identity rule"},"matchType":{"description":"The match type of the identity rule","$ref":"#/components/schemas/IdentityRuleMatchType"}}},"ApiAccessRuleType":{"enum":["Allow","Deny"]},"IdentityRuleMatchType":{"enum":["Exact","Exists","Regex"]},"ApiPolicyDeploymentViewModel":{"required":["agentGroupName"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The unique identifier of the deployment","format":"int64"},"deployerUserName":{"type":"string","description":"The username of the deployer"},"deployedUtc":{"type":"string","description":"The timestamp when the deployment occurred","format":"date-time"},"agentGroupName":{"type":"string","description":"The Agent Group associated with the deployment"}}},"JsonArray":{"type":"array"}}}}
```

## The ApiPolicyListItemViewModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyListItemViewModel":{"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The unique identifier of the API policy","format":"int64"},"name":{"type":"string","description":"The name of the policy"},"description":{"type":["null","string"],"description":"The description of the policy"}}}}}}
```

## The ApiPolicyRequestLogging object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyRequestLogging":{"required":["name","apiPolicy","loggingFieldsJson","ipLogging"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":"string"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"loggingFieldsJson":{"type":"string"},"ipLogging":{"$ref":"#/components/schemas/IpLoggingType"},"requestBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"responseBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"disableLogging":{"type":"boolean"},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyRequestLoggingDeployment"}}}},"ApiPolicy":{"required":["uniqueIdentifier","name","modifier","apiKeyName","apiKeyLocation"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"uniqueIdentifier":{"type":"string","format":"uuid"},"name":{"type":"string"},"deletedUtc":{"type":["null","string"],"format":"date-time"},"description":{"type":["null","string"]},"modifier":{"type":"string"},"modifiedUtc":{"type":"string","format":"date-time"},"allowPublicAccess":{"type":"boolean"},"apiKeyName":{"type":"string"},"apiKeyLocation":{"$ref":"#/components/schemas/ParameterLocation"},"targetEndpoints":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyTargetEndpoint"}},"identities":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyIdentity"}},"apiKeyGroups":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroup"}},"requestLoggings":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyRequestLogging"}}}},"ParameterLocation":{"enum":["Query","Header","Path","Cookie"]},"ApiPolicyTargetEndpoint":{"required":["apiPolicy","path"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"path":{"type":"string"},"method":{"$ref":"#/components/schemas/PolicyEndpointMethod"},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"PolicyEndpointMethod":{"enum":["All","Get","Post","Put","Head","Delete","Patch","Options","Connect","Trace"]},"ApiPolicyIdentity":{"required":["apiPolicy"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"isPrivateApplication":{"type":"boolean"},"issuersJson":{"type":"string"},"name":{"type":"string"},"throttlingByClaim":{"type":["null","string"]},"priorityNumber":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"identityRules":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPolicyIdentityRule"}},"deployments":{},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"ApiPolicyIdentityRule":{"required":["identity"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"identity":{"$ref":"#/components/schemas/ApiPolicyIdentity"},"ruleType":{"$ref":"#/components/schemas/ApiAccessRuleType"},"claim":{"type":"string"},"value":{"type":"string"},"matchType":{"$ref":"#/components/schemas/IdentityRuleMatchType"}}},"ApiAccessRuleType":{"enum":["Allow","Deny"]},"IdentityRuleMatchType":{"enum":["Exact","Exists","Regex"]},"ApiPolicyApiKeyGroup":{"required":["apiPolicy","name"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"name":{"type":"string"},"keyGroupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignment"}},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"ApiPolicyApiKeyGroupAssignment":{"required":["apiKey","apiKeyGroup"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiKey":{"$ref":"#/components/schemas/ApiKey"},"apiKeyGroup":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroup"}}},"ApiKey":{"required":["name","environment","modifier"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":"string"},"value":{"type":"string","format":"uuid"},"environment":{"type":"string"},"modified":{"type":"string","format":"date-time"},"modifier":{"type":"string"},"groupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignment"}}}},"IpLoggingType":{"enum":["ClientIP","ClientIPXForwardedForFirst","ClientIPXForwardedForAll","Disable"]},"ApiPolicyRequestLoggingDeployment":{"required":["apiPolicyRequestLogging","agentGroupName","deployer"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicyRequestLogging":{"$ref":"#/components/schemas/ApiPolicyRequestLogging"},"agentGroupName":{"type":"string"},"deployer":{"type":"string"},"deployedUtc":{"type":"string","format":"date-time"}}}}}}
```

## The ApiPolicyRequestLoggingDeployment object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyRequestLoggingDeployment":{"required":["apiPolicyRequestLogging","agentGroupName","deployer"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicyRequestLogging":{"$ref":"#/components/schemas/ApiPolicyRequestLogging"},"agentGroupName":{"type":"string"},"deployer":{"type":"string"},"deployedUtc":{"type":"string","format":"date-time"}}},"ApiPolicyRequestLogging":{"required":["name","apiPolicy","loggingFieldsJson","ipLogging"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":"string"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"loggingFieldsJson":{"type":"string"},"ipLogging":{"$ref":"#/components/schemas/IpLoggingType"},"requestBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"responseBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"disableLogging":{"type":"boolean"},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyRequestLoggingDeployment"}}}},"ApiPolicy":{"required":["uniqueIdentifier","name","modifier","apiKeyName","apiKeyLocation"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"uniqueIdentifier":{"type":"string","format":"uuid"},"name":{"type":"string"},"deletedUtc":{"type":["null","string"],"format":"date-time"},"description":{"type":["null","string"]},"modifier":{"type":"string"},"modifiedUtc":{"type":"string","format":"date-time"},"allowPublicAccess":{"type":"boolean"},"apiKeyName":{"type":"string"},"apiKeyLocation":{"$ref":"#/components/schemas/ParameterLocation"},"targetEndpoints":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyTargetEndpoint"}},"identities":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyIdentity"}},"apiKeyGroups":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroup"}},"requestLoggings":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyRequestLogging"}}}},"ParameterLocation":{"enum":["Query","Header","Path","Cookie"]},"ApiPolicyTargetEndpoint":{"required":["apiPolicy","path"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"path":{"type":"string"},"method":{"$ref":"#/components/schemas/PolicyEndpointMethod"},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"PolicyEndpointMethod":{"enum":["All","Get","Post","Put","Head","Delete","Patch","Options","Connect","Trace"]},"ApiPolicyIdentity":{"required":["apiPolicy"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"isPrivateApplication":{"type":"boolean"},"issuersJson":{"type":"string"},"name":{"type":"string"},"throttlingByClaim":{"type":["null","string"]},"priorityNumber":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"identityRules":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPolicyIdentityRule"}},"deployments":{},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"ApiPolicyIdentityRule":{"required":["identity"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"identity":{"$ref":"#/components/schemas/ApiPolicyIdentity"},"ruleType":{"$ref":"#/components/schemas/ApiAccessRuleType"},"claim":{"type":"string"},"value":{"type":"string"},"matchType":{"$ref":"#/components/schemas/IdentityRuleMatchType"}}},"ApiAccessRuleType":{"enum":["Allow","Deny"]},"IdentityRuleMatchType":{"enum":["Exact","Exists","Regex"]},"ApiPolicyApiKeyGroup":{"required":["apiPolicy","name"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"name":{"type":"string"},"keyGroupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignment"}},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"ApiPolicyApiKeyGroupAssignment":{"required":["apiKey","apiKeyGroup"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiKey":{"$ref":"#/components/schemas/ApiKey"},"apiKeyGroup":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroup"}}},"ApiKey":{"required":["name","environment","modifier"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":"string"},"value":{"type":"string","format":"uuid"},"environment":{"type":"string"},"modified":{"type":"string","format":"date-time"},"modifier":{"type":"string"},"groupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignment"}}}},"IpLoggingType":{"enum":["ClientIP","ClientIPXForwardedForFirst","ClientIPXForwardedForAll","Disable"]}}}}
```

## The ApiPolicyRequestLoggingSaveModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyRequestLoggingSaveModel":{"required":["deployments","name","loggingFields"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The unique identifier of the request logging. Only provide a value when updating.","format":"int64"},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyDeploymentSaveModel"},"description":"The list of deployments associated with the request logging"},"name":{"type":"string","description":"The name of the request logging"},"loggingFields":{"description":"The fields logged by request logging","$ref":"#/components/schemas/JsonArray"},"ipLogging":{"description":"IpLoggingType of the request logging","$ref":"#/components/schemas/IpLoggingType"},"requestBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Request body maximum length for request logging","format":"int32"},"responseBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Response body maximum length for request logging","format":"int32"},"disableLogging":{"type":"boolean","description":"Disable logging for request logging"}}},"ApiPolicyDeploymentSaveModel":{"required":["agentGroupName"],"type":"object","properties":{"agentGroupName":{"type":"string","description":"The Agent Group associated with the deployment"}}},"JsonArray":{"type":"array"},"IpLoggingType":{"enum":["ClientIP","ClientIPXForwardedForFirst","ClientIPXForwardedForAll","Disable"]}}}}
```

## The ApiPolicyRequestLoggingViewModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyRequestLoggingViewModel":{"required":["name","loggingFields"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The unique identifier of the request logging","format":"int64"},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyDeploymentViewModel"},"description":"The list of deployments associated with the request logging"},"name":{"type":"string","description":"The name of the request logging"},"loggingFields":{"description":"The fields logged by request logging","$ref":"#/components/schemas/JsonArray"},"ipLogging":{"description":"IpLoggingType of the request logging","$ref":"#/components/schemas/IpLoggingType"},"requestBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Request body maximum length for request logging","format":"int32"},"responseBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Response body maximum length for request logging","format":"int32"},"disableLogging":{"type":"boolean","description":"Disable logging for request logging"}}},"ApiPolicyDeploymentViewModel":{"required":["agentGroupName"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The unique identifier of the deployment","format":"int64"},"deployerUserName":{"type":"string","description":"The username of the deployer"},"deployedUtc":{"type":"string","description":"The timestamp when the deployment occurred","format":"date-time"},"agentGroupName":{"type":"string","description":"The Agent Group associated with the deployment"}}},"JsonArray":{"type":"array"},"IpLoggingType":{"enum":["ClientIP","ClientIPXForwardedForFirst","ClientIPXForwardedForAll","Disable"]}}}}
```

## The ApiPolicySaveModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicySaveModel":{"required":["targetEndpoints","name"],"type":"object","properties":{"targetEndpoints":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyTargetEndpointSaveModel"},"description":"The list of target endpoints associated with the policy"},"identities":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPolicyIdentitySaveModel"},"description":"The list of identities associated with the policy"},"apiKeyGroups":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupSaveModel"},"description":"The list of API key groups associated with the policy"},"publicAccessDeployments":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPolicyDeploymentSaveModel"},"description":"The list of deployments associated with the public access identity"},"requestLoggingOptions":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPolicyRequestLoggingSaveModel"},"description":"The list of request logging options associated with the api policy"},"name":{"type":"string","description":"The name of the policy"},"description":{"type":["null","string"],"description":"The description of the policy"},"tags":{"type":["null","array"],"items":{"type":"string"},"description":"The tags of the policy"},"allowPublicAccess":{"type":"boolean","description":"Determines if public access is allowed"},"apiKeyName":{"type":"string","description":"The name of the API key"},"apiKeyLocation":{"description":"The location of the API key","$ref":"#/components/schemas/ParameterLocation"}}},"ApiPolicyTargetEndpointSaveModel":{"required":["path"],"type":"object","properties":{"path":{"type":"string","description":"The path of the target endpoint"},"method":{"description":"The HTTP method of the target endpoint","$ref":"#/components/schemas/PolicyEndpointMethod"},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32"}}},"PolicyEndpointMethod":{"enum":["All","Get","Post","Put","Head","Delete","Patch","Options","Connect","Trace"]},"ApiPolicyIdentitySaveModel":{"required":["deployments","issuers","name"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The unique identifier of the identity. Only provide a value when updating.","format":"int64"},"identityRules":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPolicyIdentityRuleSaveModel"},"description":"The list of identity rules"},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyDeploymentSaveModel"},"description":"The list of deployments associated with the identity"},"isPrivateApplication":{"type":"boolean","description":"Determines if it is a private application"},"issuers":{"description":"The issuers of the identity","$ref":"#/components/schemas/JsonArray"},"name":{"type":"string","description":"The name of the identity"},"throttlingByClaim":{"type":["null","string"],"description":"The throttling by claim for the identity"},"priorityNumber":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"In case of 2 or more matching identities, determines which identity to use. Lower number will be selected.","format":"int32"},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32"}}},"ApiPolicyIdentityRuleSaveModel":{"required":["claim"],"type":"object","properties":{"ruleType":{"description":"The type of access rule","$ref":"#/components/schemas/ApiAccessRuleType"},"claim":{"type":"string","description":"The claim associated with the identity rule"},"value":{"type":["null","string"],"description":"The value associated with the identity rule"},"matchType":{"description":"The match type of the identity rule","$ref":"#/components/schemas/IdentityRuleMatchType"}}},"ApiAccessRuleType":{"enum":["Allow","Deny"]},"IdentityRuleMatchType":{"enum":["Exact","Exists","Regex"]},"ApiPolicyDeploymentSaveModel":{"required":["agentGroupName"],"type":"object","properties":{"agentGroupName":{"type":"string","description":"The Agent Group associated with the deployment"}}},"JsonArray":{"type":"array"},"ApiPolicyApiKeyGroupSaveModel":{"required":["apiPolicyApiKeyGroupAssignments","name"],"type":"object","properties":{"apiPolicyApiKeyGroupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignmentSaveModel"},"description":"The API key group assignments"},"name":{"type":"string","description":"The name of the API key group"},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32"}}},"ApiPolicyApiKeyGroupAssignmentSaveModel":{"required":["apiKey"],"type":"object","properties":{"apiKey":{"description":"The API key","$ref":"#/components/schemas/ApiPolicyApiKeySaveModel"}}},"ApiPolicyApiKeySaveModel":{"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The API key identifier","format":"int64"}}},"ApiPolicyRequestLoggingSaveModel":{"required":["deployments","name","loggingFields"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The unique identifier of the request logging. Only provide a value when updating.","format":"int64"},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyDeploymentSaveModel"},"description":"The list of deployments associated with the request logging"},"name":{"type":"string","description":"The name of the request logging"},"loggingFields":{"description":"The fields logged by request logging","$ref":"#/components/schemas/JsonArray"},"ipLogging":{"description":"IpLoggingType of the request logging","$ref":"#/components/schemas/IpLoggingType"},"requestBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Request body maximum length for request logging","format":"int32"},"responseBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Response body maximum length for request logging","format":"int32"},"disableLogging":{"type":"boolean","description":"Disable logging for request logging"}}},"IpLoggingType":{"enum":["ClientIP","ClientIPXForwardedForFirst","ClientIPXForwardedForAll","Disable"]},"ParameterLocation":{"enum":["Query","Header","Path","Cookie"]}}}}
```

## The ApiPolicyTargetEndpoint object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyTargetEndpoint":{"required":["apiPolicy","path"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"path":{"type":"string"},"method":{"$ref":"#/components/schemas/PolicyEndpointMethod"},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"ApiPolicy":{"required":["uniqueIdentifier","name","modifier","apiKeyName","apiKeyLocation"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"uniqueIdentifier":{"type":"string","format":"uuid"},"name":{"type":"string"},"deletedUtc":{"type":["null","string"],"format":"date-time"},"description":{"type":["null","string"]},"modifier":{"type":"string"},"modifiedUtc":{"type":"string","format":"date-time"},"allowPublicAccess":{"type":"boolean"},"apiKeyName":{"type":"string"},"apiKeyLocation":{"$ref":"#/components/schemas/ParameterLocation"},"targetEndpoints":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyTargetEndpoint"}},"identities":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyIdentity"}},"apiKeyGroups":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroup"}},"requestLoggings":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyRequestLogging"}}}},"ParameterLocation":{"enum":["Query","Header","Path","Cookie"]},"PolicyEndpointMethod":{"enum":["All","Get","Post","Put","Head","Delete","Patch","Options","Connect","Trace"]},"ApiPolicyIdentity":{"required":["apiPolicy"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"isPrivateApplication":{"type":"boolean"},"issuersJson":{"type":"string"},"name":{"type":"string"},"throttlingByClaim":{"type":["null","string"]},"priorityNumber":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"identityRules":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPolicyIdentityRule"}},"deployments":{},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"ApiPolicyIdentityRule":{"required":["identity"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"identity":{"$ref":"#/components/schemas/ApiPolicyIdentity"},"ruleType":{"$ref":"#/components/schemas/ApiAccessRuleType"},"claim":{"type":"string"},"value":{"type":"string"},"matchType":{"$ref":"#/components/schemas/IdentityRuleMatchType"}}},"ApiAccessRuleType":{"enum":["Allow","Deny"]},"IdentityRuleMatchType":{"enum":["Exact","Exists","Regex"]},"ApiPolicyApiKeyGroup":{"required":["apiPolicy","name"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"name":{"type":"string"},"keyGroupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignment"}},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"format":"int32"}}},"ApiPolicyApiKeyGroupAssignment":{"required":["apiKey","apiKeyGroup"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiKey":{"$ref":"#/components/schemas/ApiKey"},"apiKeyGroup":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroup"}}},"ApiKey":{"required":["name","environment","modifier"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":"string"},"value":{"type":"string","format":"uuid"},"environment":{"type":"string"},"modified":{"type":"string","format":"date-time"},"modifier":{"type":"string"},"groupAssignments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignment"}}}},"ApiPolicyRequestLogging":{"required":["name","apiPolicy","loggingFieldsJson","ipLogging"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":"string"},"apiPolicy":{"$ref":"#/components/schemas/ApiPolicy"},"loggingFieldsJson":{"type":"string"},"ipLogging":{"$ref":"#/components/schemas/IpLoggingType"},"requestBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"responseBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int32"},"disableLogging":{"type":"boolean"},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyRequestLoggingDeployment"}}}},"IpLoggingType":{"enum":["ClientIP","ClientIPXForwardedForFirst","ClientIPXForwardedForAll","Disable"]},"ApiPolicyRequestLoggingDeployment":{"required":["apiPolicyRequestLogging","agentGroupName","deployer"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"apiPolicyRequestLogging":{"$ref":"#/components/schemas/ApiPolicyRequestLogging"},"agentGroupName":{"type":"string"},"deployer":{"type":"string"},"deployedUtc":{"type":"string","format":"date-time"}}}}}}
```

## The ApiPolicyTargetEndpointSaveModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyTargetEndpointSaveModel":{"required":["path"],"type":"object","properties":{"path":{"type":"string","description":"The path of the target endpoint"},"method":{"description":"The HTTP method of the target endpoint","$ref":"#/components/schemas/PolicyEndpointMethod"},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32"}}},"PolicyEndpointMethod":{"enum":["All","Get","Post","Put","Head","Delete","Patch","Options","Connect","Trace"]}}}}
```

## The ApiPolicyTargetEndpointViewModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyTargetEndpointViewModel":{"required":["path"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The unique identifier of the target endpoint","format":"int64"},"path":{"type":"string","description":"The path of the target endpoint"},"method":{"description":"The HTTP method of the target endpoint","$ref":"#/components/schemas/PolicyEndpointMethod"},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32"}}},"PolicyEndpointMethod":{"enum":["All","Get","Post","Put","Head","Delete","Patch","Options","Connect","Trace"]}}}}
```

## The ApiPolicyType object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyType":{"enum":["Authentication","Logging",null]}}}}
```

## The ApiPolicyViewModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiPolicyViewModel":{"required":["name"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The identifier of the policy","format":"int64"},"uniqueIdentifier":{"type":"string","description":"The globally unique identifier of the policy","format":"uuid"},"modifier":{"type":["null","string"],"description":"The modifier of the policy"},"modifiedUtc":{"type":"string","description":"The timestamp when the policy was last modified","format":"date-time"},"targetEndpoints":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPolicyTargetEndpointViewModel"},"description":"The list of target endpoints associated with the policy"},"identities":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPolicyIdentityViewModel"},"description":"The list of identities associated with the policy"},"apiKeyGroups":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupViewModel"},"description":"The list of API key groups associated with the policy"},"publicAccessDeployments":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPolicyDeploymentViewModel"},"description":"The list of deployments connected with public access identity"},"requestLoggingOptions":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPolicyRequestLoggingViewModel"},"description":"The list of request logging options associated with the api policy"},"name":{"type":"string","description":"The name of the policy"},"description":{"type":["null","string"],"description":"The description of the policy"},"tags":{"type":["null","array"],"items":{"type":"string"},"description":"The tags of the policy"},"allowPublicAccess":{"type":"boolean","description":"Determines if public access is allowed"},"apiKeyName":{"type":"string","description":"The name of the API key"},"apiKeyLocation":{"description":"The location of the API key","$ref":"#/components/schemas/ParameterLocation"}}},"ApiPolicyTargetEndpointViewModel":{"required":["path"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The unique identifier of the target endpoint","format":"int64"},"path":{"type":"string","description":"The path of the target endpoint"},"method":{"description":"The HTTP method of the target endpoint","$ref":"#/components/schemas/PolicyEndpointMethod"},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32"}}},"PolicyEndpointMethod":{"enum":["All","Get","Post","Put","Head","Delete","Patch","Options","Connect","Trace"]},"ApiPolicyIdentityViewModel":{"required":["issuers","name"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The unique identifier of the identity","format":"int64"},"identityRules":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyIdentityRuleViewModel"}},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyDeploymentViewModel"},"description":"The list of deployments associated with the identity"},"isPrivateApplication":{"type":"boolean","description":"Determines if it is a private application"},"issuers":{"description":"The issuers of the identity","$ref":"#/components/schemas/JsonArray"},"name":{"type":"string","description":"The name of the identity"},"throttlingByClaim":{"type":["null","string"],"description":"The throttling by claim for the identity"},"priorityNumber":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"In case of 2 or more matching identities, determines which identity to use. Lower number will be selected.","format":"int32"},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32"}}},"ApiPolicyIdentityRuleViewModel":{"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The unique identifier of the identity rule","format":"int64"},"ruleType":{"description":"The type of access rule","$ref":"#/components/schemas/ApiAccessRuleType"},"claim":{"type":["null","string"],"description":"The claim associated with the identity rule"},"value":{"type":["null","string"],"description":"The value associated with the identity rule"},"matchType":{"description":"The match type of the identity rule","$ref":"#/components/schemas/IdentityRuleMatchType"}}},"ApiAccessRuleType":{"enum":["Allow","Deny"]},"IdentityRuleMatchType":{"enum":["Exact","Exists","Regex"]},"ApiPolicyDeploymentViewModel":{"required":["agentGroupName"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The unique identifier of the deployment","format":"int64"},"deployerUserName":{"type":"string","description":"The username of the deployer"},"deployedUtc":{"type":"string","description":"The timestamp when the deployment occurred","format":"date-time"},"agentGroupName":{"type":"string","description":"The Agent Group associated with the deployment"}}},"JsonArray":{"type":"array"},"ApiPolicyApiKeyGroupViewModel":{"required":["name"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The unique identifier of the API key group","format":"int64"},"apiPolicyApiKeyGroupAssignments":{"type":["null","array"],"items":{"$ref":"#/components/schemas/ApiPolicyApiKeyGroupAssignmentViewModel"},"description":"The API group assignments"},"name":{"type":"string","description":"The name of the API key group"},"requestLimit":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The maximum amount of requests. Not null value requires RequestLimitWindowInMinutes to be set.","format":"int32"},"requestLimitWindowInMinutes":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["null","integer","string"],"description":"The request limit window in minutes. Not null value requires RequestLimit to be set.","format":"int32"}}},"ApiPolicyApiKeyGroupAssignmentViewModel":{"required":["apiKey"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The identifier of the assignment","format":"int64"},"apiKey":{"description":"The API key","$ref":"#/components/schemas/ApiKeyViewModel"}}},"ApiKeyViewModel":{"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"},"name":{"type":["null","string"]},"environment":{"type":["null","string"]},"value":{"type":"string","format":"uuid"}}},"ApiPolicyRequestLoggingViewModel":{"required":["name","loggingFields"],"type":"object","properties":{"id":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"The unique identifier of the request logging","format":"int64"},"deployments":{"type":"array","items":{"$ref":"#/components/schemas/ApiPolicyDeploymentViewModel"},"description":"The list of deployments associated with the request logging"},"name":{"type":"string","description":"The name of the request logging"},"loggingFields":{"description":"The fields logged by request logging","$ref":"#/components/schemas/JsonArray"},"ipLogging":{"description":"IpLoggingType of the request logging","$ref":"#/components/schemas/IpLoggingType"},"requestBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Request body maximum length for request logging","format":"int32"},"responseBodyMaxLengthKb":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"description":"Response body maximum length for request logging","format":"int32"},"disableLogging":{"type":"boolean","description":"Disable logging for request logging"}}},"IpLoggingType":{"enum":["ClientIP","ClientIPXForwardedForFirst","ClientIPXForwardedForAll","Disable"]},"ParameterLocation":{"enum":["Query","Header","Path","Cookie"]}}}}
```

## The ApiProcessTemplateRequest object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"ApiProcessTemplateRequest":{"required":["path","operation"],"type":"object","properties":{"path":{"type":"string","description":"The path of the HTTP endpoint, as specified in the API specification"},"operation":{"type":"string","description":"The operation of the endpoint (e.g. GET)"}}}}}}
```

## The AuditLogDto object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"AuditLogDto":{"required":["user","action","parameters","timestampUtc"],"type":"object","properties":{"user":{"type":"string","description":"User name of the user who performed the action"},"action":{"type":"string","description":"Action performed by the user, in format {Controller}.{Action}"},"parameters":{"description":"Parameters of the action"},"timestampUtc":{"type":"string","description":"Timestamp of the action","format":"date-time"},"description":{"type":["null","string"],"description":"Description of the action"},"source":{"type":"string","description":"Source of the action (API, MCP, System, UI)","default":"UI"},"outcome":{"description":"Outcome of the action (Success or Failure)","$ref":"#/components/schemas/AuditOutcome"}}},"AuditOutcome":{"enum":["Success","Failure"],"default":"Success"}}}}
```

## The AuditOutcome object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"AuditOutcome":{"enum":["Success","Failure"],"default":"Success"}}}}
```

## The CertificatePurpose object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"CertificatePurpose":{"enum":["HttpsServer","ClientAuthentication","ClientCertificateIssuer"]}}}}
```

## The CommentInstancesQueryModel object

```json
{"openapi":"3.1.1","info":{"title":"Frends API","version":"1.0.0"},"components":{"schemas":{"CommentInstancesQueryModel":{"required":["comment","instanceIds"],"type":"object","properties":{"comment":{"type":"string"},"processGuids":{"type":["null","array"],"items":{"type":"string","format":"uuid"}},"instanceIds":{"type":"array","items":{"pattern":"^-?(?:0|[1-9]\\d*)$","type":["integer","string"],"format":"int64"}}}}}}}
```

## The CreateAcmeAccountRequest object

```json
[...]
